// Copyright 2015, Jean Rene Dawin
//
// This program is free software: you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation, either version 2 of the License, or
// (at your option) any later version. See License-GPL-2.txt.

#include <Elementary.h>
#include <Evas.h>
#include <Imlib2.h>
#include "escwyp_globals_extern.h"
#include "escwyp_distribs_extern.h"
#include "escwyp_distribs_gui_elm.h"
#include "escwyp_sine_robin_extern.h"

void distribsPackGui(Evas_Object *box){

   elm_box_pack_end(box, distrib_center_slider);
   evas_object_show(distrib_center_slider);

   elm_box_pack_end(box, distrib_height_slider);
   evas_object_show(distrib_height_slider);

   elm_box_pack_end(box, distrib_height_fine_slider);
   evas_object_show(distrib_height_fine_slider);

   elm_box_pack_end(box, distrib_low_slider);
   evas_object_show(distrib_low_slider);

   elm_box_pack_end(box, distrib_high_slider);
   evas_object_show(distrib_high_slider);

   elm_box_pack_end(box, box_radio);
   evas_object_show(box_radio);

   elm_box_pack_end(box_radio, distrib_radio_0);
   evas_object_show(distrib_radio_0);

   elm_box_pack_end(box_radio, distrib_radio_1);
   evas_object_show(distrib_radio_1);

   elm_box_pack_end(box_radio, distrib_radio_2);
   evas_object_show(distrib_radio_2);

   elm_box_pack_end(box_radio, distrib_radio_3);
   evas_object_show(distrib_radio_3);

   elm_box_pack_end(box, distrib_image_table);

   evas_object_show(exper_box);

   elm_box_pack_end(exper_box, distrib_image_box_left);
   evas_object_show(distrib_image_box_left);

   elm_table_pack(distrib_image_table, distrib_max_label, 0, 1, 1, 1);
   evas_object_show(distrib_max_label);

   elm_table_pack(distrib_image_table, distrib_min_label, 0, 3, 1, 1);
   evas_object_show(distrib_min_label);

   evas_object_show(im_distrib_default);
   elm_box_pack_end(exper_box, im_distrib_default);
   elm_table_pack(distrib_image_table, exper_box, 1, 1, 3, 3);

   evas_object_show(distrib_image_box_bottom);

   elm_table_pack(distrib_image_table, distrib_x_min_label, 1, 4, 1, 1);
   evas_object_show(distrib_x_min_label);

   elm_table_pack(distrib_image_table, distrib_x_max_label, 3, 4, 1, 1);
   evas_object_show(distrib_x_max_label);

   elm_table_pack(distrib_image_table, distrib_max_shown_label, 4, 1, 1, 1);
   evas_object_show(distrib_max_shown_label);

   elm_table_pack(distrib_image_table, distrib_min_shown_label, 4, 3, 1, 1);
   evas_object_show(distrib_min_shown_label);

   elm_table_pack(distrib_image_table, distrib_left_shown_label , 1, 5, 1, 1);
   evas_object_show(distrib_left_shown_label );

   elm_table_pack(distrib_image_table, distrib_right_shown_label , 3, 5, 1, 1);
   evas_object_show(distrib_right_shown_label );

   elm_box_pack_end(box, distrib_plot_step_size_slider);
   evas_object_show(distrib_plot_step_size_slider);

}

void distribsUnpackGui(Evas_Object *box){

   elm_box_unpack(box, distrib_center_slider);
   evas_object_hide(distrib_center_slider);

   elm_box_unpack(box, distrib_height_slider);
   evas_object_hide(distrib_height_slider);

   elm_box_unpack(box, distrib_height_fine_slider);
   evas_object_hide(distrib_height_fine_slider);

   elm_box_unpack(box, distrib_low_slider);
   evas_object_hide(distrib_low_slider);

   elm_box_unpack(box, distrib_high_slider);
   evas_object_hide(distrib_high_slider);

   elm_box_unpack(box, box_radio);
   evas_object_hide(box_radio);

   elm_box_unpack(box_radio, distrib_radio_0);
   evas_object_hide(distrib_radio_0);

   elm_box_unpack(box_radio, distrib_radio_1);
   evas_object_hide(distrib_radio_1);

   elm_box_unpack(box_radio, distrib_radio_2);
   evas_object_hide(distrib_radio_2);

   elm_box_unpack(box_radio, distrib_radio_3);
   evas_object_hide(distrib_radio_3);

   elm_box_unpack(box, distrib_image_table);

   evas_object_hide(exper_box);

   elm_box_unpack(exper_box, distrib_image_box_left);
   evas_object_hide(distrib_image_box_left);

   elm_table_pack(distrib_image_table, distrib_max_label, 0, 1, 1, 1);
   evas_object_hide(distrib_max_label);

   elm_table_pack(distrib_image_table, distrib_min_label, 0, 3, 1, 1);
   evas_object_hide(distrib_min_label);

   evas_object_hide(im_distrib_default);
   elm_box_unpack(exper_box, im_distrib_default);
   elm_table_pack(distrib_image_table, exper_box, 1, 1, 3, 3);

   evas_object_hide(distrib_image_box_bottom);

   elm_table_pack(distrib_image_table, distrib_x_min_label, 1, 4, 1, 1);
   evas_object_hide(distrib_x_min_label);

   elm_table_pack(distrib_image_table, distrib_x_max_label, 3, 4, 1, 1);
   evas_object_hide(distrib_x_max_label);

   elm_table_pack(distrib_image_table, distrib_max_shown_label, 4, 1, 1, 1);
   evas_object_hide(distrib_max_shown_label);

   elm_table_pack(distrib_image_table, distrib_min_shown_label, 4, 3, 1, 1);
   evas_object_hide(distrib_min_shown_label);

   elm_table_pack(distrib_image_table, distrib_left_shown_label , 1, 5, 1, 1);
   evas_object_hide(distrib_left_shown_label );

   elm_table_pack(distrib_image_table, distrib_right_shown_label , 3, 5, 1, 1);
   evas_object_hide(distrib_right_shown_label );

   elm_box_unpack(box, distrib_plot_step_size_slider);
   evas_object_hide(distrib_plot_step_size_slider);
}

void distribInitGui(){
   // the box containing all of the following
   //distrib_base_box = elm_box_add(win);
   //evas_object_size_hint_weight_set(box2, EVAS_HINT_EXPAND, EVAS_HINT_EXPAND);
   //evas_object_size_hint_align_set(box2, EVAS_HINT_FILL, EVAS_HINT_FILL);
   //elm_box_align_set(box2, 0.5, 0.0);
   //elm_box_horizontal_set(distrib_base_box, EINA_TRUE);
   //elm_box_pack_end(box_left, distrib_base_box);
   //evas_object_show(distrib_base_box);

   // the slider associated with the distrib_center parameter in the distrib functions
   distrib_center_slider = elm_slider_add(win);
   evas_object_size_hint_align_set(distrib_center_slider, EVAS_HINT_FILL, 0.5);
   evas_object_size_hint_weight_set(distrib_center_slider, EVAS_HINT_EXPAND, EVAS_HINT_EXPAND);
   elm_slider_unit_format_set(distrib_center_slider, "%1.2f center");
   elm_slider_indicator_show_set(distrib_center_slider, EINA_FALSE);
   elm_slider_min_max_set(distrib_center_slider, 0.0, 1.0);
   elm_slider_value_set(distrib_center_slider, 0.5);
   elm_slider_span_size_set(distrib_center_slider, 200);
   evas_object_smart_callback_add(distrib_center_slider, "delay,changed", distrib_center_slider_fun, NULL);    

   // the slider associated with the distrib_height parameter in the distrib functions
   distrib_height_slider = elm_slider_add(win);
   evas_object_size_hint_align_set(distrib_height_slider, EVAS_HINT_FILL, 0.5);
   evas_object_size_hint_weight_set(distrib_height_slider, EVAS_HINT_EXPAND, EVAS_HINT_EXPAND);
   elm_slider_unit_format_set(distrib_height_slider, "%1.6f height");
   elm_slider_indicator_show_set(distrib_height_slider, EINA_FALSE);
   elm_slider_min_max_set(distrib_height_slider, 0.001, 0.999);
   elm_slider_value_set(distrib_height_slider, 0.5);
   elm_slider_span_size_set(distrib_height_slider, 200);
   evas_object_smart_callback_add(distrib_height_slider, "delay,changed", distrib_height_slider_fun, NULL);    

   // the slieder for fine adjustments to distrib_height_fine_frac
   distrib_height_fine_slider = elm_slider_add(win);
   evas_object_size_hint_align_set(distrib_height_fine_slider, EVAS_HINT_FILL, 0.5);
   evas_object_size_hint_weight_set(distrib_height_fine_slider, EVAS_HINT_EXPAND, EVAS_HINT_EXPAND);
   elm_slider_unit_format_set(distrib_height_fine_slider, "%1.0f heifinfra");
   elm_slider_indicator_show_set(distrib_height_fine_slider, EINA_FALSE);
   elm_slider_min_max_set(distrib_height_fine_slider, 0.0, 200.0);
   elm_slider_value_set(distrib_height_fine_slider, 0.0);
   elm_slider_span_size_set(distrib_height_fine_slider, 200);
   evas_object_smart_callback_add(distrib_height_fine_slider, "delay,changed", distrib_height_fine_slider_fun, NULL);    

   // the slider for setting the low end of the distribution
   distrib_low_slider = elm_slider_add(win);
   evas_object_size_hint_align_set(distrib_low_slider, EVAS_HINT_FILL, 0.5);
   evas_object_size_hint_weight_set(distrib_low_slider, EVAS_HINT_EXPAND, EVAS_HINT_EXPAND);
   elm_slider_unit_format_set(distrib_low_slider, "%1.2f low");
   elm_slider_indicator_show_set(distrib_low_slider, EINA_FALSE);
   elm_slider_min_max_set(distrib_low_slider, 20.0, 2048.0);
   elm_slider_value_set(distrib_low_slider, 0.0);
   elm_slider_span_size_set(distrib_low_slider, 200);
   evas_object_smart_callback_add(distrib_low_slider, "delay,changed", distrib_low_slider_fun, NULL);    

   // the slider for setting the high end of the distribution
   distrib_high_slider = elm_slider_add(win);
   evas_object_size_hint_align_set(distrib_high_slider, EVAS_HINT_FILL, 0.5);
   evas_object_size_hint_weight_set(distrib_high_slider, EVAS_HINT_EXPAND, EVAS_HINT_EXPAND);
   elm_slider_unit_format_set(distrib_high_slider, "%1.2f high");
   elm_slider_indicator_show_set(distrib_high_slider, EINA_FALSE);
   elm_slider_min_max_set(distrib_high_slider, 20.0, 2048.0);
   elm_slider_value_set(distrib_high_slider, 2048.0);
   elm_slider_span_size_set(distrib_high_slider, 200);
   evas_object_smart_callback_add(distrib_high_slider, "delay,changed", distrib_high_slider_fun, NULL);    

   box_radio = elm_box_add(win);
   //evas_object_size_hint_weight_set(box2, EVAS_HINT_EXPAND, EVAS_HINT_EXPAND);
   //evas_object_size_hint_align_set(box2, EVAS_HINT_FILL, EVAS_HINT_FILL);
   //elm_box_align_set(box2, 0.5, 0.0);
   elm_box_horizontal_set(box_radio, EINA_TRUE);

   distrib_radio_0 = elm_radio_add(win);
   elm_radio_state_value_set(distrib_radio_0, 0);
   elm_object_part_text_set(distrib_radio_0, NULL, "Equal");
   evas_object_smart_callback_add(distrib_radio_0, "changed", distrib_radio_fun, NULL);    

   distrib_radio_1 = elm_radio_add(win);
   elm_radio_state_value_set(distrib_radio_1, 1);
   elm_radio_group_add(distrib_radio_1, distrib_radio_0);
   elm_object_part_text_set(distrib_radio_1, NULL, "Spiky");
   evas_object_smart_callback_add(distrib_radio_1, "changed", distrib_radio_fun, NULL);    

   distrib_radio_2 = elm_radio_add(win);
   elm_radio_state_value_set(distrib_radio_2, 2);
   elm_radio_group_add(distrib_radio_2, distrib_radio_0);
   elm_object_part_text_set(distrib_radio_2, NULL, "Smooth");
   evas_object_smart_callback_add(distrib_radio_2, "changed", distrib_radio_fun, NULL);    

   distrib_radio_3 = elm_radio_add(win);
   elm_radio_state_value_set(distrib_radio_3, 3);
   elm_radio_group_add(distrib_radio_3, distrib_radio_0);
   elm_object_part_text_set(distrib_radio_3, NULL, "Umver");
   evas_object_smart_callback_add(distrib_radio_3, "changed", distrib_radio_fun, NULL);    

   // the table containing the image and the labels for the description
   distrib_image_table = elm_table_add(win);
   evas_object_show(distrib_image_table);
   elm_table_padding_set(distrib_image_table, 2, 2);

   exper_box = elm_box_add(win);
   //evas_object_size_hint_weight_set(box2, EVAS_HINT_EXPAND, EVAS_HINT_EXPAND);
   //evas_object_size_hint_align_set(box2, EVAS_HINT_FILL, EVAS_HINT_FILL);
   //elm_box_align_set(box2, 0.5, 0.0);
   elm_box_horizontal_set(exper_box, EINA_TRUE);
   //elm_table_pack(distrib_image_table, exper_box, 1, 0, 1, 1);
   //elm_box_pack_end(distrib_base_box, exper_box);


   
   // the box to the left of the image containing the y-max/min-Values 
   distrib_image_box_left = elm_box_add(win);
   //evas_object_size_hint_weight_set(box2, EVAS_HINT_EXPAND, EVAS_HINT_EXPAND);
   //evas_object_size_hint_align_set(box2, EVAS_HINT_FILL, EVAS_HINT_FILL);
   //elm_box_align_set(box2, 0.5, 0.0);
   elm_box_horizontal_set(distrib_image_box_left, EINA_FALSE);

   distrib_max_label = elm_label_add(win);
   elm_object_text_set(distrib_max_label, "y-Max");
   //elm_box_pack_end(distrib_image_box_left, disrib_max_label);

   distrib_min_label = elm_label_add(win);
   elm_object_text_set(distrib_min_label, "y-Min");
   //elm_box_pack_end(distrib_image_box_left , distrib_min_label);

   distrib_center_label = elm_label_add(win);
   elm_object_text_set(distrib_center_label, "Center");
   //elm_box_pack_end(distrib_image_box_left , distrib_center_label);
   //elm_object_content_set(scr_distrib, distrib_center_label);


   pixels = malloc(sizeof(unsigned int)*distrib_image_width*distrib_image_height); 
   int i,j;
   for(i = 0; i < distrib_image_width*distrib_image_height; i++){

      pixels[i] = 0xFFFFFFFF;
      //fprintf(stdout, "%x, ", pixels[i]);

   }
   //unsigned int lasttwo;
   //for(i = 0; i < distrib_image_height; i++){
   //   lasttwo = (unsigned int) roundf(255.0*i/distrib_image_height);
   //   for(j = 0; j < distrib_image_width; j++){

   //      if( ((i*distrib_image_width+j) < 0) ||  ((i*distrib_image_width+j) >= distrib_image_width*distrib_image_height) ){
   //         fprintf(stdout, "C Bad ix %i \n", i*distrib_image_width+j);
   //      }

   //      pixels[i*distrib_image_width+j] = 0xFF258300+lasttwo;
   //   }
   //}

   canv = evas_object_evas_get(win);
   //ee = ecore_evas_new(NULL, 0, 0, distrib_image_width, distrib_image_height, NULL);
   //ecore_evas_size_min_set(ee, distrib_image_width, distrib_image_height);
   //ecore_evas_size_max_set(ee, distrib_image_width, distrib_image_height);
   //ecore_evas_show(ee);
   //canv = ecore_evas_get(ee);

   // the image to be shown after start up in the image-scroller below
   im_distrib_default = evas_object_image_add(canv);

   evas_object_image_alpha_set(im_distrib_default, EINA_TRUE);
   evas_object_image_size_set(im_distrib_default, distrib_image_width, distrib_image_height);
   evas_object_image_data_set(im_distrib_default, pixels);
   //evas_object_image_file_set(im_distrib_default, "escwtiny.png", NULL);
   evas_object_image_colorspace_set(im_distrib_default, EVAS_COLORSPACE_ARGB8888);
   evas_object_image_fill_set(im_distrib_default, 0, 0, distrib_image_width, distrib_image_height);
   evas_object_image_filled_set(im_distrib_default, EINA_TRUE);
   evas_object_resize(im_distrib_default, distrib_image_width, distrib_image_height);
   evas_object_size_hint_max_set(im_distrib_default, distrib_image_width, distrib_image_height);
   evas_object_size_hint_min_set(im_distrib_default, distrib_image_width, distrib_image_height);
   evas_object_size_hint_weight_set(im_distrib_default, 0.0, 0.0);
   evas_object_size_hint_align_set(im_distrib_default, EVAS_HINT_FILL, EVAS_HINT_FILL);
   //evas_object_color_set(im_distrib_default, 0, 128, 30, 200); /* 50% opaque green */
   //elm_box_pack_end(distrib_base_box, im_distrib_default);
   //elm_table_pack(distrib_image_table, im_distrib_default, 1, 1, 3, 3);

   //Eina_File *eif = eina_file_virtualize("imfilechen", pixels, sizeof(unsigned int)*distrib_image_width*distrib_image_height, EINA_TRUE);

   //Evas_Object *anim = elm_image_add(win);
   //elm_image_file_set(anim, "/home/the/escw.png", NULL);
   ////elm_image_file_set(anim, "demokurve1.png", NULL);
   ////elm_image_mmap_set(anim, eif, NULL);
   ////elm_image_memfile_set(anim, pixels, sizeof(unsigned int)*distrib_image_width*distrib_image_height, "pmaps", NULL);
   //elm_image_resizable_set(anim, EINA_TRUE, EINA_FALSE);
   ////elm_win_resize_object_add(win, anim);
   //evas_object_size_hint_weight_set(anim, EVAS_HINT_EXPAND, EVAS_HINT_EXPAND);
   //evas_object_size_hint_align_set(anim, EVAS_HINT_FILL, EVAS_HINT_FILL);
   //evas_object_show(anim);
   ////elm_box_pack_end(box, anim);

   //// the image-scroller to show a graph of the current distributuin
   //scr_distrib = elm_scroller_add(win);
   ////elm_win_resize_object_add(win, scr_distrib);
   //evas_object_size_hint_weight_set(scr_distrib, EVAS_HINT_EXPAND, EVAS_HINT_EXPAND);
   //evas_object_size_hint_align_set(scr_distrib, EVAS_HINT_FILL, EVAS_HINT_FILL);
   //evas_object_size_hint_min_set(scr_distrib, distrib_image_width+10, distrib_image_height+10);
   //evas_object_size_hint_max_set(scr_distrib, distrib_image_width+20, distrib_image_height+20);
   //// the content_min_limit is very important here
   //elm_scroller_content_min_limit(scr_distrib, EINA_TRUE, EINA_TRUE);
   //elm_scroller_page_size_set(scr_distrib, distrib_image_width+10, distrib_image_height+10);
   //elm_object_content_set(scr_distrib, im_distrib_default);
   ////elm_table_pack(distrib_image_table, scr_distrib, 0, 0, 1, 1);
   //elm_box_pack_end(exper_box, scr_distrib);
   //elm_table_pack(distrib_image_table, exper_box, 1, 1, 3, 3);
   //evas_object_show(scr_distrib);
   //evas_object_resize(im_distrib_default, distrib_image_width, distrib_image_height);

   //// the image to be shown after start up in the image-scroller below
   //im_distrib_default = elm_image_add(win);
   ////elm_image_file_set(im_distrib_default, "/home/the/stool/demokurve0.png", NULL);
   //elm_image_resizable_set(im_distrib_default, EINA_TRUE, EINA_FALSE);
   ////elm_win_resize_object_add(win, im);
   //evas_object_size_hint_weight_set(im_distrib_default, EVAS_HINT_EXPAND, EVAS_HINT_EXPAND);
   //evas_object_size_hint_align_set(im_distrib_default, EVAS_HINT_FILL, EVAS_HINT_FILL);
   //evas_object_show(im_distrib_default);
   ////elm_box_pack_end(exper_box, im);


   //// the image-scroller to show a graph of the current distributuin
   //scr_distrib = elm_scroller_add(win);
   ////elm_win_resize_object_add(win, scr_distrib);
   //evas_object_size_hint_weight_set(scr_distrib, EVAS_HINT_EXPAND, EVAS_HINT_EXPAND);
   //evas_object_size_hint_align_set(scr_distrib, EVAS_HINT_FILL, EVAS_HINT_FILL);
   //evas_object_size_hint_min_set(scr_distrib, distrib_image_width+10, distrib_image_height+10);
   //evas_object_size_hint_max_set(scr_distrib, distrib_image_width+10, distrib_image_height+10);
   //elm_scroller_content_min_limit(scr_distrib, EINA_TRUE, EINA_TRUE);
   //elm_scroller_page_size_set(scr_distrib, distrib_image_width+10, distrib_image_height+10);
   //evas_object_show(scr_distrib);
   //elm_object_content_set(scr_distrib, im_distrib_default);
   ////elm_table_pack(distrib_image_table, scr_distrib, 0, 0, 1, 1);
   //elm_box_pack_end(exper_box, scr_distrib);
   //elm_table_pack(distrib_image_table, exper_box, 1, 1, 3, 3);

   // the box below the image containing the x-max/min-Values 
   distrib_image_box_bottom = elm_box_add(win);
   //evas_object_size_hint_weight_set(box2, EVAS_HINT_EXPAND, EVAS_HINT_EXPAND);
   //evas_object_size_hint_align_set(box2, EVAS_HINT_FILL, EVAS_HINT_FILL);
   //elm_box_align_set(box2, 0.5, 0.0);
   elm_box_horizontal_set(distrib_image_box_bottom, EINA_TRUE);
   //elm_table_pack(distrib_image_table, distrib_image_box_bottom, 1, 1, 1, 1);
   //elm_box_pack_end(box_left, distrib_image_box_bottom);

   distrib_x_min_label = elm_label_add(win);
   elm_object_text_set(distrib_x_min_label, "x-Min");
   //elm_box_pack_end(distrib_image_box_bottom, distrib_x_min_label);

   distrib_x_max_label = elm_label_add(win);
   elm_object_text_set(distrib_x_max_label, "x-Max");
   //elm_box_pack_end(distrib_image_box_bottom, distrib_x_max_label);

   distrib_max_shown_label = elm_label_add(win);
   elm_object_text_set(distrib_max_shown_label, "y-Max");
   //elm_box_pack_end(distrib_image_box_left, disrib_max_label);

   distrib_min_shown_label = elm_label_add(win);
   elm_object_text_set(distrib_min_shown_label, "y-Min");
   //elm_box_pack_end(distrib_image_box_left , distrib_min_label);

   distrib_left_shown_label = elm_label_add(win);
   elm_object_text_set(distrib_left_shown_label , "left");
   //elm_box_pack_end(distrib_image_box_left, disrib_max_label);

   distrib_right_shown_label = elm_label_add(win);
   elm_object_text_set(distrib_right_shown_label , "right");
   //elm_box_pack_end(distrib_image_box_left , distrib_min_label);

   // the slider for setting the step_size for plotting smples of the distrib starting from the center to the left and the right
   distrib_plot_step_size_slider = elm_slider_add(win);
   evas_object_size_hint_align_set(distrib_plot_step_size_slider, EVAS_HINT_FILL, 0.5);
   evas_object_size_hint_weight_set(distrib_plot_step_size_slider, EVAS_HINT_EXPAND, EVAS_HINT_EXPAND);
   elm_slider_unit_format_set(distrib_plot_step_size_slider, "%1.0f plt stp sz");
   elm_slider_indicator_show_set(distrib_plot_step_size_slider, EINA_FALSE);
   elm_slider_min_max_set(distrib_plot_step_size_slider, 1.0, 40.0);
   elm_slider_value_set(distrib_plot_step_size_slider, 20.0);
   elm_slider_span_size_set(distrib_plot_step_size_slider, 200);
   evas_object_smart_callback_add(distrib_plot_step_size_slider, "delay,changed", distrib_plot_step_size_slider_fun, NULL);    

   makeEqualDistribution(distrib_size, distrib_low, distrib_high, distrib, dist_marks, &distrib_minimum, &distrib_maximum);
   makeDistribImage();
}



void makeDistribImage(){

   int out_pixels[distrib_image_width];
   //int width_step = 2; // 2048/100
   int center = (int) roundf(distrib_center*(distrib_high - distrib_low));

   int i;
   //for(i = 20; i < 40; i++){
   //   fprintf(stdout, "P distrib[%i] = %f, dist_marks[%i] = %i\n", i, distrib[i], i-20, dist_marks[i-20]);
   //}

   for(i = 0; i < distrib_image_width; i++){
      //fprintf(stdout, "Jeee %i %f max: %f\n", i, distrib[i], distrib_maximum);
      out_pixels[i] = distrib_image_height-1;
   }

   int helper = 0;
   float local_max = 0.0;
   int lowest_index = distrib_image_width;

   // set values for the labels
   char label_text[20];
   snprintf(label_text, 20*sizeof(char), "%f", distrib_maximum);
   elm_object_text_set(distrib_max_label, label_text);

   snprintf(label_text, 20*sizeof(char), "%f", distrib_minimum);
   elm_object_text_set(distrib_min_label, label_text);

   snprintf(label_text, 20*sizeof(char), "%i", distrib_center_scalar);
   elm_object_text_set(distrib_center_label, label_text);

   snprintf(label_text, 20*sizeof(char), "%i", distrib_high);
   elm_object_text_set(distrib_x_max_label, label_text);

   snprintf(label_text, 20*sizeof(char), "%i", distrib_low);
   elm_object_text_set(distrib_x_min_label, label_text);

   for(i = center; i < distrib_high; i+=plot_step_width){
      if(distrib[i] > local_max){
         local_max = distrib[i];
      }
      if(i < lowest_index){
         lowest_index = i;
      }
   }
   for(i = center - plot_step_width; i > distrib_low; i-=plot_step_width){
      if(distrib[i] > local_max){
         local_max = distrib[i];
      }
      if(i < lowest_index){
         lowest_index = i;
      }
   }

   if(local_max == 0.0){
      local_max = 1.0;
   }

   float distrib_low_shown = 1.0;
   float distrib_high_shown = 0.0;
   int distrib_left_shown = 2048;
   int distrib_right_shown = 0;

   int j = (int) roundf(distrib_image_width*(1.0*center)/distrib_high);
   for(i = center; i < distrib_high; i+=plot_step_width){
      if(i > 2047 || i < 0){
         fprintf(stdout, "A bad ix %i\n", i);
      }
      helper = (int) roundf((distrib_image_height-1) * distrib[i]/local_max);
      if( j < distrib_image_width ){ 
         out_pixels[j] = (distrib_image_height-1) - helper;
         if(distrib_low_shown > distrib[i]){
            distrib_low_shown = distrib[i];
         } 
         if(distrib_high_shown < distrib[i]){
            distrib_high_shown = distrib[i];
         } 
         if(distrib_left_shown > i){
            distrib_left_shown = i;
         } 
         if(distrib_right_shown < i){
            distrib_right_shown = i;
         } 
         //fprintf(stdout, "Jei %i %i ---  %i %f / %f cent: %i, dc: %f\n", j, out_pixels[j], i, distrib[i], local_max, center, distrib[center]);
      j++;
      }else{
         break;
      }
   }
   fprintf(stdout, "After ze new loops A\n");
   j = (int) roundf(distrib_image_width*(1.0*center)/distrib_high);
   --j;
   for(i = center - plot_step_width; i > distrib_low; i-=plot_step_width){
      if(i > 2047 || i < 0){
         fprintf(stdout, "B bad ix %i\n", i);
      }
      helper = (int) roundf((distrib_image_height-1) * distrib[i]/local_max);
      if( j >= 0 ){ 
         out_pixels[j] = (distrib_image_height-1) - helper;
         if(distrib_low_shown > distrib[i]){
            distrib_low_shown = distrib[i];
         } 
         if(distrib_high_shown < distrib[i]){
            distrib_high_shown = distrib[i];
         } 
         if(distrib_left_shown > i){
            distrib_left_shown = i;
         } 
         if(distrib_right_shown < i){
            distrib_right_shown = i;
         } 
         //fprintf(stdout, "Jei %i %i ---  %i %f / %f cent: %i, dc: %f\n", j, out_pixels[j], i, distrib[i], local_max, center, distrib[center]);
      --j;
      }else{
         break;
      }
   }

   fprintf(stdout, "After ze new loops B\n");

   snprintf(label_text, 20*sizeof(char), "%f", distrib_low_shown);
   elm_object_text_set(distrib_min_shown_label , label_text);

   snprintf(label_text, 20*sizeof(char), "%f", distrib_high_shown);
   elm_object_text_set(distrib_max_shown_label , label_text);

   snprintf(label_text, 20*sizeof(char), "%i", distrib_left_shown );
   elm_object_text_set(distrib_left_shown_label , label_text);

   snprintf(label_text, 20*sizeof(char), "%i", distrib_right_shown );
   elm_object_text_set(distrib_right_shown_label , label_text);
   //int j = 0;
   //for(i = lowest_index; i < distrib_high; i+=plot_step_width){
   //   helper = (int) roundf((distrib_image_height-1) * distrib[i]/local_max);
   //   out_pixels[j] = (distrib_image_height-1) - helper;
   //   //fprintf(stdout, "Jei %i %i ---  %i %f / %f cent: %i, dc: %f\n", j, out_pixels[j], i, distrib[i], local_max, center, distrib[center]);
   //   j++;
   //}

   unsigned int lasttwo;
   for(i = 0; i < distrib_image_height; i++){
      lasttwo = (unsigned int) roundf(255.0*i/distrib_image_height);
      for(j = 0; j < distrib_image_width; j++){

         if( ((i*distrib_image_width+j) < 0) ||  ((i*distrib_image_width+j) >= distrib_image_width*distrib_image_height) ){
            fprintf(stdout, "C Bad ix %i \n", i*distrib_image_width+j);
         }

         pixels[i*distrib_image_width+j] = 0xFF258300+lasttwo;
      }
   }
   int out_pixel;
   //int prev_min = distrib_image_height;
   //int prev_max = distrib_image_height;
   int caught;

   // for the first (0th) Pixel
   out_pixel = out_pixels[0];
   pixels[out_pixel*distrib_image_width] = 0xFFFFFFFF;
   int prev_min = out_pixel;
   int prev_max = out_pixel;

   for(i = 1; i < distrib_image_width; i++){
      out_pixel = out_pixels[i];
      caught = 0;
      if(out_pixel > prev_max){
         for(j = prev_max+1; j < out_pixel; j++){ 
            if( ((j*distrib_image_width+i) < 0) ||  ((j*distrib_image_width+i) >= distrib_image_width*distrib_image_height) ){
               fprintf(stdout, "D Bad ix %i \n", j*distrib_image_width+i);
            }

            pixels[j*distrib_image_width+i] = 0xFFFFFFFF;
         }
         //pixels[out_pixel*distrib_image_width+i] = 0xFFCC2222;
            if( ((out_pixel*distrib_image_width+i) < 0) ||  ((out_pixel*distrib_image_width+i) >= distrib_image_width*distrib_image_height) ){
               fprintf(stdout, "D' Bad ix %i \n", out_pixel*distrib_image_width+i);
            }
         pixels[out_pixel*distrib_image_width+i] = 0xFFFFFFFF;
         prev_min = prev_max+1;
         prev_max = out_pixel;
         caught = 1;
      }
      if(out_pixel < prev_min && !caught){
         for(j = prev_min-1; j > out_pixel; j--){ 
            if( ((j*distrib_image_width+i) < 0) ||  ((j*distrib_image_width+i) >= distrib_image_width*distrib_image_height) ){
               fprintf(stdout, "E Bad ix %i \n", j*distrib_image_width+i);
            }
            pixels[j*distrib_image_width+i] = 0xFFFFFFFF;
         }
         //pixels[out_pixel*distrib_image_width+i] = 0xFFCC2222;
            if( ((out_pixel*distrib_image_width+i) < 0) ||  ((out_pixel*distrib_image_width+i) >= distrib_image_width*distrib_image_height) ){
               fprintf(stdout, "E' Bad ix %i \n", out_pixel*distrib_image_width+i);
            }
         pixels[out_pixel*distrib_image_width+i] = 0xFFFFFFFF;
         prev_max = prev_min-1;
         prev_min = out_pixel;
         caught = 1;
      }
      if(caught == 0){
         //pixels[out_pixel*distrib_image_width+i] = 0xFFCC2222;
            if( ((out_pixel*distrib_image_width+i) < 0) ||  ((out_pixel*distrib_image_width+i) >= distrib_image_width*distrib_image_height) ){
               fprintf(stdout, "F Bad ix %i \n", out_pixel*distrib_image_width+i);
            }
         pixels[out_pixel*distrib_image_width+i] = 0xFFFFFFFF;
         prev_max = out_pixel;
         prev_min = out_pixel;
      } 
      //fprintf(stdout, "%i(%f), ", out_pixel, tmp_sound_buff[i]);
   }
   fprintf(stdout, "HIER? \n");

   evas_object_image_data_update_add(im_distrib_default, 0, 0, distrib_image_width, distrib_image_height);
   fprintf(stdout, "HIER AUCH? \n");

   ////for(i = center - plot_step_width; i > distrib_low; i-=plot_step_width){
   ////     helper = (int) roundf(distrib_image_height * distrib[i*plot_step_width]/local_max);
   ////     out_pixels[i] = distrib_image_height - helper;
   ////}


   ////ImlibPolygon thepoly = imlib_polygon_new(); 
   ////for (i = 0; i < distrib_image_width; i++){
   ////   imlib_polygon_add_point(thepoly, i, out_pixels[i]);
   ////   //fprintf(stdout, "Jeee %i %i \n", i, out_pixels[i]);
   ////   //imlib_polygon_add_point(thepoly, i, 15);
   ////   //fprintf(stdout, "%i %i\n", i, konta[i]);
   ////}

   ////Imlib_Image theim = imlib_create_image(distrib_image_width, distrib_image_height);
   ////imlib_context_set_image(theim);
   ////imlib_context_set_color(255, 255, 255, 255);
   ////imlib_image_fill_rectangle(0, 0, distrib_image_width, distrib_image_height);
   //////imlib_context_set_color(55, 155, 100, 255);
   //////imlib_image_fill_polygon(thepoly);
   ////imlib_context_set_color(0, 0, 0, 255);
   ////imlib_image_draw_polygon(thepoly, 0);
   //////char imt[13];
   //////sprintf(imt, "d1 %i/d2 %i", da, db);
   //////Imlib_Font ilfo = imlib_load_font("FreeMono/10");
   //////imlib_context_set_font(ilfo);
   //////if(ilfo == NULL){
   //////   fprintf(stdout, "NULL 0000000 %s\n", imt);
   //////}else{
   //////   fprintf(stdout, "LLUN 1111111 %s\n", imt);
   //////}
   //////fprintf(stdout, "LULN 2 %s\n", imt);
   //////imlib_text_draw(2, 2, imt);
   ////imlib_image_set_format("png");
   ////int image_size2 = distrib_image_width*distrib_image_height*sizeof(DATA32); 
   ////int image_size = imlib_get_cache_size();
   ////fprintf(stdout, "IMAGE S I Z E: %i (2): %i\n", image_size, image_size2);
   //////DATA32 *image_data = imlib_image_get_data_for_reading_only();
  
   //////imlib_save_image("/tmp/distrib_image.png");
   ////evas_object_image_memfile_set(im_distrib_default, theim, image_size2, "png", NULL);
   ////imlib_polygon_free(thepoly);
   ////imlib_free_image();

   //////if(im_distrib_default != NULL){
   //////   evas_object_del(im_distrib_default);
   //////}
   //////elm_image_file_set(im_distrib_default, "/tmp/distrib_image.png", NULL);
   ////elm_image_resizable_set(im_distrib_default, EINA_TRUE, EINA_FALSE);
   //////elm_win_resize_object_add(win, im_distrib_default);
   ////evas_object_size_hint_weight_set(im_distrib_default, EVAS_HINT_EXPAND, EVAS_HINT_EXPAND);
   ////evas_object_size_hint_align_set(im_distrib_default, EVAS_HINT_FILL, EVAS_HINT_FILL);
   ////evas_object_show(im_distrib_default);

   ////elm_object_content_set(scr_distrib, im_distrib_default);

}

//static
static void distrib_center_slider_fun(void *data, Evas_Object *obj, void *event_info){

   fprintf(stdout, "Yis distrib_center_slider_fun\n");
   distrib_center = (float) elm_slider_value_get(obj);
   fprintf(stdout, "DISTRIB_CENTER %f\n", distrib_center);

   update_distrib(1);

}

//static
static void distrib_height_slider_fun(void *data, Evas_Object *obj, void *event_info){

   fprintf(stdout, "Yis distrib_height_slider_fun\n");
   distrib_height =  (float) elm_slider_value_get(obj);
   //if(distrib_height < 0.5){
   //   distrib_height_fine =  distrib_height/200;
   //}else{
   //   distrib_height_fine =  (1.0-distrib_height)/200;
   //}

   update_distrib(1);

   fprintf(stdout, "DISTRIB_HEIGHT %f\n", distrib_height);

}

//static
static void distrib_height_fine_slider_fun(void *data, Evas_Object *obj, void *event_info){

   fprintf(stdout, "Yis distrib_height_fine_slider_fun\n");

   distrib_height_fine_frac =  (float) elm_slider_value_get(obj);
   //if(distrib_height < 0.5){
   //   distrib_height_fine =  distrib_height/200;
   //}else{
   //   distrib_height_fine =  1.0-distrib_height/200;
   //}

   update_distrib(1);

   fprintf(stdout, "DISTRIB_FINE_HEIGHT %f\n", distrib_height_fine_frac);

}


//static
static void distrib_low_slider_fun(void *data, Evas_Object *obj, void *event_info){

   //not used
   data = NULL;
   //not used
   event_info = NULL;

   distrib_low =  (int) round(elm_slider_value_get(obj));
   if(distrib_high < distrib_low){ 
      int distrib_low_tmp = distrib_low;
      distrib_low = distrib_high;
      distrib_high = distrib_low_tmp;
   } 

   fprintf(stdout, "Before Switch distriblow = %i, distrib_high = %i\n", distrib_low, distrib_high);

   update_distrib(1);

   fprintf(stdout, "After Switch distriblow = %i, distrib_high = %i\n", distrib_low, distrib_high);

}

//static
static void distrib_high_slider_fun(void *data, Evas_Object *obj, void *event_info){

   distrib_high =  (int) round(elm_slider_value_get(obj));
   if(distrib_high < distrib_low){ 
      int distrib_low_tmp = distrib_low;
      distrib_low = distrib_high;
      distrib_high = distrib_low_tmp;
   } 
   fprintf(stdout, "H Before Switch distriblow = %i, distrib_high = %i\n", distrib_low, distrib_high);
   
   update_distrib(1);

   fprintf(stdout, "H After Switch distriblow = %i, distrib_high = %i\n", distrib_low, distrib_high);

}


//static
static void distrib_radio_fun(void *data, Evas_Object *obj, void *event_info){

   fprintf(stdout, "Yis distrib_radio_fun\n");
   distrib_radio_val = elm_radio_value_get(obj);
   //Evas_Object *im_distrib = elm_image_add(win);

   update_distrib(1);

   fprintf(stdout, "DISTRIB_RADIO_VAL %i\n", distrib_radio_val);

}

static void distrib_plot_step_size_slider_fun(void *data, Evas_Object *obj, void *event_info){
   
   fprintf(stdout, "Yis distrib_plot_step_size_slider_fun\n");
   plot_step_width = (int) roundf(elm_slider_value_get(obj));
   fprintf(stdout, "PLOT_STEP_WIDTH %i\n", plot_step_width);
   makeDistribImage();


}

float get_distrib_center(){

   return distrib_center;

}
void set_distrib_center(float a_center){

   if(a_center >= 0.0 && a_center <= 1.0){
      distrib_center = a_center;
   }else{
      fprintf(stdout, "bad try to set distrib_center (%f).\n", a_center);
   }

}

void refresh_distrib(float a_center){

   if(a_center >= 0.0 && a_center <= 1.0){
      distrib_center = a_center;
   }else{
      fprintf(stdout, "bad try to set distrib_center (%f).\n", a_center);
   }

   // the "0" means don't call makeDistribImage
   update_distrib(0);
   //TODO: this function doesn't exist. Check if a call like this is needed.
   //sine_robin_set_dist_marks(dist_marks);

}

static void update_distrib(const int make_dist_img){

   switch(distrib_radio_val){

      case 0: {
                 makeEqualDistribution(distrib_size, distrib_low, distrib_high, distrib, dist_marks, &distrib_minimum, &distrib_maximum);
              }
              break;
      case 1: {
                 distrib_height_fine =  distrib_height/200;
                 makeDistri(distrib_size, distrib_low, distrib_high, distrib_center, distrib_height-(distrib_height_fine_frac*distrib_height_fine), distrib, dist_marks, &distrib_minimum, &distrib_maximum);
              }
              break;
      case 2: {
                 distrib_height_fine =  (1.0-distrib_height)/200;
                 makeDistriByParting(distrib_size, distrib_low, distrib_high, distrib_center, distrib_height+(distrib_height_fine_frac*distrib_height_fine), distrib, dist_marks, &distrib_minimum, &distrib_maximum);

              }
              break;
      case 3: {
                 distrib_height_fine =  distrib_height/200;
                 makeDistriByUmverteilung(distrib_size, distrib_low, distrib_high, distrib_center, distrib_height-(distrib_height_fine_frac*distrib_height_fine), distrib, dist_marks, &distrib_minimum, &distrib_maximum);
              }
              break;

   }
   if(make_dist_img == 1){
      makeDistribImage();
   }

}

void distribs_distrib_center_slider_set(const float value){

        elm_slider_value_set(distrib_center_slider, (double) value);

}
void distribs_distrib_height_slider_set(const float value){

        elm_slider_value_set(distrib_height_slider, (double) value);

}
void distribs_distrib_height_fine_slider_set(const float value){

        elm_slider_value_set(distrib_height_fine_slider, (double) value);

}
void distribs_distrib_low_slider_set(const float value){

        elm_slider_value_set(distrib_low_slider, (double) value);

}
void distribs_distrib_high_slider_set(const float value){

        elm_slider_value_set(distrib_high_slider, (double) value);

}
void distribs_distrib_radio_0_set(const int value){

        elm_radio_value_set(distrib_radio_0, value);

}
void distribs_distrib_plot_step_size_slider_set(const float value){

        elm_slider_value_set(distrib_plot_step_size_slider, (double) value);

}


