// Copyright 2015, Jean Rene Dawin
//
// This program is free software: you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation, either version 2 of the License, or
// (at your option) any later version. See License-GPL-2.txt.

#ifndef ESCWYP_DISTRIBS_GUI_ELM_H
#define ESCWYP_DISTRIBS_GUI_ELM_H

#include <Evas.h>

static unsigned int *pixels;

// the center and height/fine parameters for the distribution functions
static int distrib_size = 2048;
static float distrib[2048];
static float dist_marks[2048];
 
static float distrib_center = 0.5;
static int distrib_center_scalar = 0; 
static float distrib_height = 0.5;
static float distrib_height_fine  = 0.0;
static float distrib_height_fine_frac = 0.0;

//// the maximum and minimum values of the current distribution  
static float distrib_maximum = 1.0;
static float distrib_minimum = 0.0;

// width and height of the graph of the distribution displayed
static const int distrib_image_width = 100;
static const int distrib_image_height = 50;

static int distrib_low = 0;
static int distrib_high = 2048;

static int plot_step_width = 20;
// the value of the radio buttons selcting the distribution function
static int distrib_radio_val, distrib_low, distrib_high;

static Evas_Object *distrib_center_slider; 
static Evas_Object *distrib_height_slider;
static Evas_Object *box_radio; 
static Evas_Object *distrib_radio_0; 
static Evas_Object *distrib_radio_1; 
static Evas_Object *distrib_radio_2; 
static Evas_Object *distrib_radio_3; 
static Evas *canv;
static Evas_Object *im_distrib_default;
static Evas_Object *distrib_image_table; 
static Evas_Object *distrib_image_box_left; 
static Evas_Object *distrib_image_box_bottom;
static Evas_Object *exper_box; 
static Evas_Object *distrib_height_fine_slider;
static Evas_Object *distrib_max_label; 
static Evas_Object *distrib_min_label; 
static Evas_Object *distrib_x_min_label; 
static Evas_Object *distrib_x_max_label; 
static Evas_Object *distrib_center_label; 
static Evas_Object *distrib_max_shown_label; 
static Evas_Object *distrib_min_shown_label; 
static Evas_Object *distrib_left_shown_label ; 
static Evas_Object *distrib_right_shown_label ; 
static Evas_Object *scr_distrib;
static Evas_Object *distrib_high_slider; 
static Evas_Object *distrib_low_slider;
static Evas_Object *distrib_plot_step_size_slider;
//static Ecore_Evas *ee;

static void distrib_center_slider_fun(void *data, Evas_Object *obj, void *event_info);
static void distrib_height_slider_fun(void *data, Evas_Object *obj, void *event_info);
static void distrib_height_fine_slider_fun(void *data, Evas_Object *obj, void *event_info);
static void distrib_low_slider_fun(void *data, Evas_Object *obj, void *event_info);
static void distrib_high_slider_fun(void *data, Evas_Object *obj, void *event_info);
static void distrib_radio_fun(void *data, Evas_Object *obj, void *event_info);
static void distrib_plot_step_size_slider_fun(void *data, Evas_Object *obj, void *event_info);

float get_distrib_center();
void set_distrib_center(float a_center);
void refresh_distrib(float a_center);
static void update_distrib(const int make_dist_img);

void distribsPackGui(Evas_Object *box);
void distribsUnpackGui(Evas_Object *box);

void makeDistribImage();
void distribs_distrib_center_slider_set(const float value);
void distribs_distrib_height_slider_set(const float value);
void distribs_distrib_height_fine_slider_set(const float value);
void distribs_distrib_low_slider_set(const float value);
void distribs_distrib_high_slider_set(const float value);
void distribs_distrib_radio_0_set(const int value);
void distribs_distrib_plot_step_size_slider_set(const float value);

#endif
