// Copyright 2014-2015, Jean Rene Dawin
//
// This Library is free software: you can redistribute it and/or modify
// it under the terms of the GNU Lesser General Public License as published by
// the Free Software Foundation, either version 2.1 of the License, or
// (at your option) any later version.
//
// This Library is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU Lesser General Public License for more details.
//
// You should have received a copy of the GNU Lesser General Public License
// along with this Library.  If not, see <http://www.gnu.org/licenses/>.

#include <stdio.h>
#include <string.h>
#include <math.h>
#include "random_aux.h"
//#include "escwyp_globals_extern.h"
#include "escwyp_nadelper.h"


void nadelper_default_params(struct nadelper_params *the_params)
{

   //the_params->nadelper_max_num_freqs = 100;
   //the_params->nadelper_nadel_size = 0.1;
   //the_params->nadelper_num_freqs = 40;
   // these three arrays are not initialized here but in nadelper_init_values-> Evil but simple.
   //the_params->nadelper_freqs[100];
   //the_params->nadelper_signs[100];
   //the_params->nadelper_remainders[100];
   the_params->nadelper_lowest_freq = 1;
   //the_params->nadelper_highest_freq = 10000;
   //the_params->nadelper_freq_step_size = 10;
   //the_params->nadelper_random_step_size_active = 0;
   //the_params->nadelper_step_size_random_range = 1;


}

void print_params_nadelper(struct nadelper_params *the_params)
{

   if(the_params != NULL){

      fprintf(stdout, "-----------------\n");
      //fprintf(stdout, "nadelper_max_num_freqs %i\n", the_params->nadelper_max_num_freqs);
      //fprintf(stdout, "nadelper_nadel_size %f\n", the_params->nadelper_nadel_size);
      //fprintf(stdout, "nadelper_num_freqs %i\n", the_params->nadelper_num_freqs);
      int i;
      for(i = 0; i < nadelper_num_freqs; i++){
         fprintf(stdout, "nadelper_freqs[100] %i, ", the_params->nadelper_freqs[i]);
      }
      fprintf(stdout, "\n");
      for(i = 0; i < nadelper_num_freqs; i++){
         fprintf(stdout, "nadelper_signs[100] %i, ", the_params->nadelper_signs[i]); 
      }
      fprintf(stdout, "\n");
      for(i = 0; i < nadelper_num_freqs; i++){
         fprintf(stdout, "nadelper_remainders[100] %i, ", the_params->nadelper_remainders[i]);
      }
      fprintf(stdout, "\n");
      fprintf(stdout, "nadelper_lowest_freq %i\n", the_params->nadelper_lowest_freq);
      //fprintf(stdout, "nadelper_highest_freq %i\n", the_params->nadelper_highest_freq);
      //fprintf(stdout, "nadelper_freq_step_size %i\n", the_params->nadelper_freq_step_size);
      //fprintf(stdout, "nadelper_random_step_size_active %i\n", the_params->nadelper_random_step_size_active);
      //fprintf(stdout, "nadelper_step_size_random_range %i\n", the_params->nadelper_step_size_random_range);
      fprintf(stdout, "-----------------\n");
   }else{
      fprintf(stdout, "Pardon, no params set.\n");
   }
}


void nadelper_refresh_parameters()
{

   // this should be called, but with thought
   //nadelper_init_values();

   //the_params->nadelper_highest_freq = (int) elm_slider_value_get(nadelper_highest_freq_slider) + the_params->nadelper_lowest_freq;
   //the_params->lawn_length_variation_max = (int) trunc(the_params->lawn_length*lawn_length_variation_frac); 
   //if(the_params->lawn_length_variation_max  == 0){
   //   the_params->lawn_length_variation = 0;
   //}

}

void nadelper_set_params(struct nadelper_params *params)
{

   the_params = params;
}

void nadelper_set_freq(const float freq)
{

   the_params->nadelper_lowest_freq = (int) roundf(freq);
   fprintf(stdout, " ----------------- SPRATZ_LOWEST_FREQ = %i\n", the_params->nadelper_lowest_freq);

}

void nadelper_set_freq_from_klavier(const float freq, const float low_freq, const float high_freq)
{

   if(!self_control){
      float tmp_freq = 1000 - (freq - low_freq)/(high_freq - low_freq)*(1000 - 1);
      the_params->nadelper_lowest_freq = (int) roundf(tmp_freq);
   }
}

void nadelper_init_values()
{


   int tmp_freq = the_params->nadelper_lowest_freq;
   int j;
   for(j = 0; j < nadelper_num_freqs; j++){
      if(tmp_freq <= nadelper_highest_freq){
         the_params->nadelper_freqs[j] = tmp_freq;
         fprintf(stdout, "F%i = %i, ", j, the_params->nadelper_freqs[j]);
         if(nadelper_random_step_size_active == 1){
            int tmp_rand = int_random(-nadelper_step_size_random_range+1, nadelper_step_size_random_range-1); 
            tmp_freq += nadelper_freq_step_size+tmp_rand;
         }else{
            tmp_freq += nadelper_freq_step_size;
         }
      }else{
         the_params->nadelper_freqs[j] = 0;
      }

      the_params->nadelper_signs[j] = 1;

      the_params->nadelper_remainders[j] = the_params->nadelper_freqs[j];
      //fprintf(stdout, "Freq %i Rest %i\n", the_params->nadelper_freqs[j], the_params->nadelper_remainders[j]);
   }
   fprintf(stdout, "\n");

}

//---------------- This function is called when key4 is pressed -------------------

void makeNadelper(const int length, float *buff_L)
{

   int i, j;
   for(i = 0; i < length; i++){
      buff_L[i] = 0;
   }

   for(i = 0; i < nadelper_num_freqs; i++){
      if(the_params->nadelper_freqs[i] > 0){
         // the "- 1" below is needed to align the freqs/wavelengths with the array indices of "output[j + k*length]"
         // aftrer the "while" loop "+ 1 " is added to "j" again to readjust this
         j = the_params->nadelper_remainders[i] - 1;
         while(j < length){
            buff_L[j] += (float) nadelper_nadel_size*the_params->nadelper_signs[i];
            the_params->nadelper_signs[i] *= -1;
            j+=the_params->nadelper_freqs[i]; 
         }
         // the " + 1" here readjusts for array index vs. frequency/wavelength difference (see comment above)
         the_params->nadelper_remainders[i] = j - length + 1;
         //fprintf(stdout, "Freq %i Rest %i\n", the_params->nadelper_freqs[i], the_params->nadelper_remainders[i]);
      }
   }
}

//-------------------------------------------------------------

// GET / SET -----------

int nadelper_get_max_num_freqs()
{

        return nadelper_max_num_freqs;

}

float nadelper_get_nadel_size()
{

        return nadelper_nadel_size;

}

int nadelper_get_num_freqs()
{

        return nadelper_num_freqs;

}

int nadelper_get_highest_freq()
{

        return nadelper_highest_freq;

}

int nadelper_get_freq_step_size()
{

        return nadelper_freq_step_size;

}

int nadelper_get_random_step_size_active()
{

        return nadelper_random_step_size_active;

}

int nadelper_get_step_size_random_range()
{

        return nadelper_step_size_random_range;

}


void nadelper_set_max_num_freqs(const int value)
{

        //nadelper_max_num_freqs = value;

}

void nadelper_set_nadel_size(const float value)
{

        nadelper_nadel_size = value;

}

void nadelper_set_num_freqs(const int value)
{

        nadelper_num_freqs = value;

}

void nadelper_set_highest_freq(const int value)
{

        nadelper_highest_freq = value;

}

void nadelper_set_freq_step_size(const int value)
{

        nadelper_freq_step_size = value;

}

void nadelper_set_random_step_size_active(const int value)
{

        nadelper_random_step_size_active = value;

}

void nadelper_set_step_size_random_range(const int value)
{

        nadelper_step_size_random_range = value;

}


//----------- PARAMS_STUFF
int nadelper_params_lowest_freq_get()
{

	return the_params->nadelper_lowest_freq;

}

void nadelper_params_lowest_freq_set(const int val)
{

	the_params->nadelper_lowest_freq = val;

}

void nadelper_set_self_control(const int value)
{
    self_control = value;
}
int nadelper_get_self_control()
{
    return self_control;
}

