// Copyright 2014-2015, Jean Rene Dawin
//
// This Library is free software: you can redistribute it and/or modify
// it under the terms of the GNU Lesser General Public License as published by
// the Free Software Foundation, either version 2.1 of the License, or
// (at your option) any later version.
//
// This Library is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU Lesser General Public License for more details.
//
// You should have received a copy of the GNU Lesser General Public License
// along with this Library.  If not, see <http://www.gnu.org/licenses/>.

#ifndef ESCWYP_NADELPER_EXTERN_H
#define ESCWYP_NADELPER_EXTERN_H
#include "escwyp_nadelper_params.h"


void nadelper_default_params(struct nadelper_params *the_params);
void print_params_nadelper(struct nadelper_params *the_params);

void nadelper_refresh_parameters();
void nadelper_set_params(struct nadelper_params *params);
void nadelper_set_freq(const float freq);
void nadelper_set_freq_from_klavier(const float freq, const float low_freq, const float high_freq);

void nadelper_init_values();
void makeNadelper(const int length, float *buff_L);

//--- GET/SET ------
int nadelper_get_max_num_freqs();
float nadelper_get_nadel_size();
int nadelper_get_num_freqs();
int nadelper_get_highest_freq();
int nadelper_get_freq_step_size();
int nadelper_get_random_step_size_active();
int nadelper_get_step_size_random_range();

void nadelper_set_max_num_freqs(const int value);
void nadelper_set_nadel_size(const float value);
void nadelper_set_num_freqs(const int value);
void nadelper_set_highest_freq(const int value);
void nadelper_set_freq_step_size(const int value);
void nadelper_set_random_step_size_active(const int value);
void nadelper_set_step_size_random_range(const int value);

//----------- PARAMS_STUFF
int nadelper_params_lowest_freq_get();
void nadelper_params_lowest_freq_set(const int val);

void nadelper_set_self_control(const int value);
int nadelper_get_self_control();

#endif
