// Copyright 2015, Jean Rene Dawin
//
// This program is free software: you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation, either version 2 of the License, or
// (at your option) any later version. See License-GPL-2.txt.

#include <stdio.h>
#include <stdlib.h>
#include <errno.h>
#include <poll.h>
#include <pthread.h>
#include <alsa/asoundlib.h>
#include "escwyp_globals_extern.h"
#include "escwyp_out_alsa.h"
#include "escwyp_misch_extern.h"
#include "escwyp_out_txt_extern.h"
#include "escwyp_main.h"
#include <time.h>
#include <unistd.h>
// robinet d'isolement du marchepied
// ALSA sound out Linux

static void *processAlsa(void *args)
{


	int caught = 0;
	time_t seconds = 0;
	long nanoseconds = 100000; // 4 millisekunden
	struct timespec the_ts;
	the_ts.tv_sec = seconds;
	the_ts.tv_nsec = nanoseconds;

	while(1){

		//caught = 0;
		//if(buff_leere == 0 && playsth == 0 && oszill_drawn == 0){

		//	fprintf(stdout, "OSZ %i\n", oszillcount); 
		//	buff_leere = 0;
		//	oszill_drawn = 1;
		//	caught = 1;
		//}

		//if(buff_leere == 1 && playsth == 0){
		if(playsth == 0){

			play_alsa(sound_buffer_length, wartemal);
   			outTxtCopy(sound_buffer_length, wartemal);
			//pselect(0, NULL, NULL, NULL, &the_ts, NULL);
			//fprintf(stdout, "F W A R T E = \n"); 
			buff_leere = 0;
			//oszill_drawn = 0;
			//caught = 1;
		}

        // Pustet nochmal den buffer durch bevor direkt danach Sound reinkommt
		if(playsth != 0 && buff_leere == 0){

			play_alsa(sound_buffer_length, wartemal);
			buff_leere = 1;
		}

		// When sound is going to be precessed we enter here  -------------
		if(playsth != 0){

			//current_sound_function = 1;
			misch(sound_buffer_length);
			play_alsa(sound_buffer_length, buff_L);
   			outTxtCopy(sound_buffer_length, buff_L);
			buff_leere = 2;
			caught = 1;

		}

		if(buff_leere == 2 && playsth < 0){
			//int i;
			//sample_t nframes_fact = 1.0;
			//sample_t nframes_fact_subtract = 1.0;

			//if(nframes > 1){
			//   nframes_fact_subtract = (sample_t) 1.0/(nframes-1);
			//}

			//for(i = 0; i < nframes; i++){
			//   out[i] *= nframes_fact;
			//   nframes_fact -= nframes_fact_subtract;
			//}
			//fprintf(stdout, "E N V E L O P E %i %f fact=%f\n", nframes, out[nframes-1], nframes_fact); 
			misch(sound_buffer_length);
			buff_leere = 1;
			playsth = 0;
			caught = 1;
		}
		//if(!caught){
		//	//fprintf(stdout, "Gecaught.\n");
		//	pselect(0, NULL, NULL, NULL, &the_ts, NULL);
		//}
                int semv = -1;
                sem_getvalue(&stop_sem, &semv);
		if(semv == 0){
		   break;
		}
	}
	sem_post(&stop_sem);
	return args;
}
// -----------------------------
static int setAlsaHwParamsPlay(){

    int error_state = 0;
    int wasserstand = 0;

    int card_result = -1;
    int card_num = 0;
    while(card_num >= 0){
        snd_card_next(&card_result);
        if(card_result == 0){
            fprintf(stdout, "Karte %i (result = %i)\n", card_num, card_result);
            ++card_num;
        }else{
            fprintf(stdout, "No Karte %i\n", card_result);
            card_num = -1;
        }
    }
    fprintf(stdout, "8\n");

    snd_pcm_hw_params_t *hwparams;

    snd_pcm_hw_params_alloca(&hwparams);
    fprintf(stdout, "9\n");

    wasserstand = snd_pcm_open(&pcm_handle, pcm_name, stream, SND_PCM_NONBLOCK);
    if(wasserstand < 0){
        fprintf(stdout, "Error opening PCM device %s [%i] \n", pcm_name, wasserstand);
        error_state -= 1;
    }
    fprintf(stdout, "9.\n");

    if(pcm_handle){
        wasserstand = snd_pcm_hw_params_any(pcm_handle, hwparams);
        if(wasserstand < 0){
            fprintf(stdout, "Can not configure this PCM device. [%i]\n", wasserstand);
            error_state -= 1;
        }
        fprintf(stdout, "9..\n");

        wasserstand = snd_pcm_hw_params_set_access(pcm_handle, hwparams, SND_PCM_ACCESS_RW_INTERLEAVED);
        if(wasserstand < 0){
            fprintf(stdout, "Error setting access. [%i]\n", wasserstand);
            error_state -= 1;
        }
        fprintf(stdout, "9...\n");

        wasserstand = snd_pcm_hw_params_set_format(pcm_handle, hwparams, SND_PCM_FORMAT_FLOAT_LE);
        if(wasserstand < 0){
            fprintf(stdout, "Error setting format. [%i]\n", wasserstand);
            error_state -= 1;
        }
        fprintf(stdout, "9....\n");

        exact_rate = sample_rate;
        wasserstand = snd_pcm_hw_params_set_rate_near(pcm_handle, hwparams, &exact_rate, 0);
        if(wasserstand < 0){
            fprintf(stdout, "Error setting sample_rate. [%i]\n", wasserstand);
            error_state -= 1;
        }

        if (sample_rate != exact_rate) {
            fprintf(stdout, "The sample_rate %d Hz is not supported by your hardware.\n ==> Using %d Hz instead.\n", sample_rate, exact_rate);
        }
        fprintf(stdout, "9aaa\n");

        wasserstand = snd_pcm_hw_params_set_channels(pcm_handle, hwparams, 2);
        if(wasserstand < 0){
            fprintf(stdout, "Error setting channels. [%i]\n", wasserstand);
            error_state -= 1;
        }
        fprintf(stdout, "9aa\n");

        //wasserstand = snd_pcm_hw_params_set_periods(pcm_handle, hwparams, periods, dir);
        //if(wasserstand < 0){
        //   fprintf(stdout, "Error setting periods. [%i]\n", wasserstand);
        //   error_state -= 1;
        //}
        fprintf(stdout, "9a\n");

        wasserstand = snd_pcm_hw_params_set_period_size_near(pcm_handle, hwparams, &period_size, &dir);
        if(wasserstand < 0){
            fprintf(stdout, "Error setting period_size. [%i]\n", wasserstand);
            error_state -= 1;
        }

        wasserstand = snd_pcm_hw_params_set_buffer_size_near(pcm_handle, hwparams, &buffer_size);
        if(wasserstand < 0){
            fprintf(stdout, "Error setting buffersize. [%i]\n", wasserstand);
            error_state -= 1;
        }
        fprintf(stdout, "9b\n");

        wasserstand = snd_pcm_hw_params(pcm_handle, hwparams);
        if(wasserstand < 0){
            fprintf(stdout, "Error setting HW params. [%i]\n", wasserstand);
            error_state -= 1;
        }
    }

    fprintf(stdout, "9c\n");
    return error_state;
}



static int setAlsaSwParamsPlay(){


    snd_pcm_sw_params_t *swparams;
    snd_pcm_sw_params_alloca(&swparams);

    int wasserstand = 0;
    int error_state = 0;

    wasserstand = snd_pcm_sw_params_current(pcm_handle, swparams);
    if (wasserstand < 0) {
        fprintf(stdout, "Unable to determine current swparams for playback: %s\n", snd_strerror(wasserstand));
        error_state -= 1;
    }

    wasserstand = snd_pcm_sw_params_set_start_threshold(pcm_handle, swparams, start_threshold);
    if (wasserstand < 0) {
        fprintf(stdout, "Unable to set start threshold mode for playback: %s\n", snd_strerror(wasserstand));
        error_state -= 1;
    }

    wasserstand = snd_pcm_sw_params_set_avail_min(pcm_handle, swparams, period_event ? buffer_size : period_size);
    if (wasserstand < 0) {
        fprintf(stdout, "Unable to set avail min for playback: %s\n", snd_strerror(wasserstand));
        error_state -= 1;
    }

    if (period_event) {
        wasserstand = snd_pcm_sw_params_set_period_event(pcm_handle, swparams, 1);
        if (wasserstand < 0) {
            fprintf(stdout, "Unable to set period event: %s\n", snd_strerror(wasserstand));
            error_state -= 1;
        }
    }

    wasserstand = snd_pcm_sw_params(pcm_handle, swparams);
    if (wasserstand < 0) {
        fprintf(stdout, "Unable to set sw params for playback: %s\n", snd_strerror(wasserstand));
        error_state -= 1;
    }

    if(error_state < 0){
        return -1;
    }else{
        return 0;
    }

}



static int putSound2(float *sound, const int repeats, const int frames, const int close_device){


    //snd_pcm_sframes_t snd_pcm_writei(pcm_handle, data, num_frames);
    //fprintf(stdout, "10\n");
    snd_pcm_uframes_t num_frames = period_size;
    if(frames > 0){
        num_frames = (snd_pcm_uframes_t) frames;
    }

    if(sound != NULL){

        //fprintf(stdout, "Am Playen ...\n");
        int pcmreturn, i;
        for(i = 0; i < repeats; i++) {

            if(pcm_handle){
               snd_pcm_wait(pcm_handle, 200);
               while ((pcmreturn = snd_pcm_writei(pcm_handle, sound + 2*num_frames*i, num_frames)) < 0) {
                  fprintf(stdout, "Could not output to ALSA. Error: %i\n", pcmreturn);
                  snd_pcm_prepare(pcm_handle);
               }
	    }else{
	      fprintf(stdout, "2 2 H A  HA   H    A HA HA\n");
            }
            //fprintf(stdout, " playreturn = %i \n", pcmreturn);
        } 
    }
    if(close_device){
        /* Stop PCM device and drop pending frames */
        snd_pcm_drop(pcm_handle);
        snd_pcm_close(pcm_handle);
    }
    return 0;
}


void escwyp_alsa_close_device(){

   if(pcm_handle){
      snd_pcm_drop(pcm_handle);
      snd_pcm_close(pcm_handle);
   }

}

int escwyp_out_alsa_init(){

    sample_rate = 48000; /* Sample rate */
    exact_rate = 0;   /* Sample rate returned by */
    /* snd_pcm_hw_params_set_rate_near */ 
    dir = 0;          /* exact_rate == sample_rate --> dir = 0 */
    /* exact_rate < sample_rate  --> dir = -1 */
    /* exact_rate > sample_rate  --> dir = 1 */
    periods = 1;       /* Number of periods */
    period_event = 0;
    create_buffers(sound_buffer_length);
    //snd_pcm_uframes_t periodsize = 8192; /* Periodsize (bytes) */
    period_size = sound_buffer_length; /* Periodsize (bytes) */
    buffer_size = period_size*periods; /* Periodsize (bytes) */
    start_threshold = buffer_size/2; /* when to start transport */
        escwyp_alsa_abuff_init();
        fprintf(stdout, "Ready? abuff = %x.\n", abuff);

    sem_init(&stop_sem, 0, 1);

    // ALSA initializing stuff playback
    pcm_handle = NULL;          
    /* Playback stream */
    stream = SND_PCM_STREAM_PLAYBACK;

    pcm_name = "default";

    int reti = -1;
    if(setAlsaHwParamsPlay() == 0 && setAlsaSwParamsPlay() == 0){
        //Hier wird der Tread definiert, der processAlsa() aufruft. Der Thread beendet sich selbst
        //wenn processAlsa() zurückkehrt. Damit er dabei seine Ressourcen freigibt muss in athred_attr
        //d. h. den Attributen des Threads PTHREAD_CREATE_DETACHED gesetzt werden (man pthread_create).  
        pthread_attr_t alsa_thread_attr;
        pthread_attr_init(&alsa_thread_attr);
        pthread_attr_setdetachstate(&alsa_thread_attr, PTHREAD_CREATE_DETACHED);
        reti = pthread_create(&alsa_thread, &alsa_thread_attr, &processAlsa, &sound_buffer_length);

        fprintf(stdout, "Ready to play. %i\n", reti);
    }
    return reti;

}

void escwyp_alsa_abuff_init()
{

   abuff = (float *) malloc(2*sound_buffer_length*sizeof(float));

}

void escwyp_alsa_abuff_free()
{

   if(abuff){
      free(abuff);
   }

}
void play_alsa(const int sound_buffer_length, const float *sound_buff){

	int i;
	//fprintf(stdout, "B U G : %x sbl=%i \n", sound_buff, sound_buffer_length);
	/*abuff[0] = 1.0;*/
	for(i = 0; i < sound_buffer_length; ++i){
	   //fprintf(stdout, "BUGplaz_alsa: %i\n", i);
		abuff[2*i] = sound_buff[i];
		abuff[2*i+1] = sound_buff[i];
	}
	putSound2(abuff, 1, sound_buffer_length, 0);

}

int escwyp_out_alsa_stop()
{
   int reti = 0;
   if(pcm_handle){
	time_t seconds = 0;
	time_t secondsb = 0;
	//long nanoseconds = 100000; // 4 millisekunden
	long nanoseconds = 0; 
	long nanosecondsb = 0; 
	struct timespec the_ts;
	the_ts.tv_sec = seconds;
	the_ts.tv_nsec = nanoseconds;
        clock_gettime(CLOCK_MONOTONIC, &the_ts);
        secondsb = the_ts.tv_sec;
        nanosecondsb = the_ts.tv_nsec;
      //fprintf(stdout, "%i, %li sec, %li nsecs - Killing the alsa thread:\n", sizeof(long), the_ts.tv_sec, the_ts.tv_nsec);
      int sr_stop = sem_wait(&stop_sem);
      //fprintf(stdout, "Killed the alsa thread. First stop. %i\n", sr_stop);
      sr_stop = sem_wait(&stop_sem);
        clock_gettime(CLOCK_MONOTONIC, &the_ts);
      //fprintf(stdout, "%i, %li sec, %li nsecs - 2Killing the alsa thread:\n", sizeof(long), the_ts.tv_sec, the_ts.tv_nsec);
        time_t secdiff = the_ts.tv_sec - secondsb;
        long nsecdiff = the_ts.tv_nsec - nanosecondsb;
        if(nsecdiff < 0){
            nsecdiff = 1000000000 + nsecdiff;
        }
        if(nsecdiff > nanosecondsm){
           nanosecondsm = nsecdiff;
        }
        if(nsecdiff < nanosecondsk){
           nanosecondsk = nsecdiff;
        }
        fprintf(stdout, "DIFF %li sec, %li nsecs min_nsec/max_nsec %li/%li\n", secdiff, nsecdiff, nanosecondsk, nanosecondsm);
      fprintf(stdout, "Killed the alsa thread. Second stop. %i\n", sr_stop);
      escwyp_alsa_close_device();
      escwyp_alsa_abuff_free();
      pcm_handle = NULL;
      reti = 1;
      sem_destroy(&stop_sem);
      fprintf(stdout, "Done Kildwled the alsa thread.\n");
   }
   return reti;
}
