// Copyright 2015, Jean Rene Dawin
//
// This program is free software: you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation, either version 2 of the License, or
// (at your option) any later version. See License-GPL-2.txt.

#ifndef ESCWYP_OUT_ALSA_H
#define ESCWYP_OUT_ALSA_H
#include <semaphore.h>

long nanosecondsm = 0; 
long nanosecondsk = 1000000000; 
unsigned int sample_rate; /* Sample rate */
unsigned int exact_rate;   /* Sample rate returned by */
/* snd_pcm_hw_params_set_rate_near */ 
int dir;          /* exact_rate == sample_rate --> dir = 0 */
/* exact_rate < sample_rate  --> dir = -1 */
/* exact_rate > sample_rate  --> dir = 1 */
int periods;       /* Number of periods */
int period_event;
int num_slices;
float *abuff;
static pthread_t alsa_thread; 
//snd_pcm_uframes_t periodsize; /* Periodsize (bytes) */
snd_pcm_uframes_t period_size; /* Periodsize (bytes) */
snd_pcm_uframes_t buffer_size; /* Periodsize (bytes) */
snd_pcm_uframes_t start_threshold; /* when to start transport */

// ALSA initializing stuff playback
snd_pcm_t *pcm_handle;          
/* Playback stream */
snd_pcm_stream_t stream;

// Semaphore to signal the infinite loop in processAlsa
// that it should finish.
// Initially stop_sem is set to 1. If it is set to 1
// the loop will break causing the thread to end.
// Shortly before processAlsa returns, it posts stop_sem to be 1.
// So the code demanding the loop to finish can sem_wait on stop_sem
// and will wake up when the thread has ended. Roughly.
static sem_t stop_sem;


/* Name of the PCM device, like plughw:0,0          */
/* The first number is the number of the soundcard, */
/* the second number is the number of the device.   */
char *pcm_name;

static void *processAlsa(void *args);
static int setAlsaHwParamsPlay();
static int setAlsaSwParamsPlay();
static int putSound2(float *sound, const int repeats, const int frames, const int close_device);
void escwyp_alsa_close_device();
int escwyp_out_alsa_init();
int escwyp_out_alsa_stop();
void escwyp_alsa_abuff_init();
void escwyp_alsa_abuff_free();
void play_alsa(const int sound_buffer_length, const float *sound_buff);

#endif
