// Copyright 2015, Jean Rene Dawin
//
// This Library is free software: you can redistribute it and/or modify
// it under the terms of the GNU Lesser General Public License as published by
// the Free Software Foundation, either version 2.1 of the License, or
// (at your option) any later version. See http://www.gnu.org/licenses/

#include "escwyp_globals_extern.h"
#include "escwyp_out_txt.h"
//#include "escwyp_rec_gui_elm_extern.h"
#include "escwyp_utils_extern.h"
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <pthread.h>
#include <errno.h>
#ifdef ESCWYP_SNDFILE_YES
#include "libsamplot.h"
#endif
static void *processTxt(void *args)
{

   fprintf(stdout, "2 TXTTXTTXT processTxt\n");
   struct buffpart *bpp = &buffs[write_index];
   outputSoundAsText(bpp->bf, bpp->b);
#ifdef ESCWYP_SNDFILE_YES
   outputSoundAsWav(bpp->bf, bpp->b);
#endif
   if(escwyp_rec_btns_cb != NULL){
      //escwyp_rec_btns_cb();
   }

   bpp->bf = 0; 
   sem_post(&sem);
   sem_post(&bpp->s);
   fprintf(stdout, "2>> TXTTXTTXT processTxt\n");
   return NULL;

}

static int init_write_thread(int index)
{

   int ret = 1;
   int sr = sem_trywait(&sem);
   int se = errno;
   if(sr != 0){
      fprintf(stdout, "Could not get semaphore of out_txt: ret=%i err=%i\n", sr, se);
      //if(se == EAGAIN){fprintf(stdout, "EAGAIN Could not get semaphore of out_txt: ret=%i err=%i\n", sr, se);}
   }else{
      int semv = 0;
      sem_getvalue(&sem, &semv);
      fprintf(stdout, "Got semaphore of out_txt: ret=%i val=%i\n", sr, semv);

      write_index = index;
      //recHideBtn();
      pthread_t txt_thread; 
      pthread_attr_t txt_thread_attr;
      pthread_attr_init(&txt_thread_attr);
      pthread_attr_setdetachstate(&txt_thread_attr, PTHREAD_CREATE_DETACHED);
      int tr = pthread_create(&txt_thread, &txt_thread_attr, &processTxt, NULL);
      if(tr == 0){
         ret = 0;
      }else{
         ret = 2;
      }
   }
   return ret;

}

void outTxtCopy(const int length, const float *buff)
{

 
   //fprintf(stdout, "0 TXTTXT outTxtCopy %i\n", output_txt);
   int semv = -1;
   int sr = -1;
   int se = -1;
   //sr = sem_getvalue(&sem, &semv);
   struct buffpart *bpp = &buffs[buffs_index];
   sem_t *semn = &bpp->s;
   sr = sem_trywait(semn);
   se = errno;
   //fprintf(stdout, "buffs_index=%i\n", buffs_index);
      //fprintf(stdout, "Cannot get trywait of semaphore of out_txt: ret=%i err=%i val=%i\n", sr, se, semv);
      //fprintf(stdout, "Cannot get trywait of semaphore of out_txt: ret=%i err=%i (%i)\n", sr, se, EAGAIN);
   int wt = 1;
   if(sr == 0){ 

      //fprintf(stdout, "II Semaphore of out_txt has return %i\n", sr);
      if(output_txt == 4){
         fprintf(stdout, "Close the file!\n");
         int sr = sem_trywait(&sem);
         int se = errno;
         if(sr != 0){
            fprintf(stdout, "4>> Could not get semaphore of out_txt: ret=%i err=%i\n", sr, se);
            //if(se == EAGAIN){fprintf(stdout, "EAGAIN Could not get semaphore of out_txt: ret=%i err=%i\n", sr, se);}
         }else{
            int semv = 0;
            sem_getvalue(&sem, &semv);
            fprintf(stdout, "4>> Got semaphore of out_txt: ret=%i val=%i\n", sr, semv);
            samplot_close_file(sndfile);
            sndfile = NULL;
            txt_buff_index = 0;
            txt_buff_fill = 0.0;
            sem_post(semn); 
            sem_post(&sem); 
            set_output_txt(0);
            if(escwyp_rec_progress_cb != NULL){
               escwyp_rec_progress_cb(txt_buff_fill);
            }
            afterSoundAsText(txt_out_result);
         }
      }
      if(output_txt == 3){
         fprintf(stdout, "1aa TXTTXTTXT outTxtCopy STOP!\n");
         wt = init_write_thread(buffs_index);
         fprintf(stdout, ">> starting rest wegputzen: wt=%i output_txt=%i\n", wt, output_txt);
         if(wt == 0){
            set_output_txt(4);
         }
      }else if(txt_buff_index > 0 && output_txt == 0){
         fprintf(stdout, "1a TXTTXTTXT outTxtCopy\n");
         //wt = init_write_thread(buffs_index);
      }
      if(length >= 0 && output_txt == 2){
         txt_out_result = 2;
         wav_out_result = 2;
         //fprintf(stdout, "22a TXTTXTTXT outTxtCopy bi=%i\n", buffs_index);
         int copy_chunk = txt_buff_index + length;
         if(copy_chunk <= txt_buff_length){
            memcpy(bpp->b+txt_buff_index, buff, length*sizeof(float));
            txt_buff_index += length;
            bpp->bf = txt_buff_index; 
            float perc = 1.0*copy_chunk/txt_buff_length;
            if(perc - txt_buff_fill > 0.1){
           	txt_buff_fill = perc;
           	if(escwyp_rec_progress_cb != NULL){
                   //escwyp_rec_progress_cb(txt_buff_fill);
                }
            	//bar_rec_fun(txt_buff_fill); //TODO: Craches on high frequency calls.
                //char bla[32];
                //snprintf(bla, 32, "%f", perc);//TODO: Craches on high frequency calls.
                //lab_rec_fun(0, bla);
            }
            //fprintf(stdout, "1 TXTTXTTXT outTxtCopy %i %i %i %f\n", txt_buff_index, txt_buff_length, length, perc);
         }else{
            fprintf(stdout, "1b TXTTXTTXT outTxtCopy\n");
            wt = init_write_thread(buffs_index);
         }
      }
   }
   if(sr < 0){
      //fprintf(stdout, "Semaphore of out_txt has value %i\n", semv);
      fprintf(stdout, "SR>> Cannot get value of semaphore of out_txt: ret=%i err=%i\n", sr, se);
   }
   if(output_txt != 4){
      if(wt == 0){
         buffs_index++;
         buffs_index %= buffs_num;
         txt_buff_index = 0;
         txt_buff_fill = 0.0;
      }
      if(wt == 1){
         sem_post(semn); 
      }
      if(wt < 0){
         txt_buff_index = 0;
         txt_buff_fill = 0.0;
         sem_post(semn); 
      }
   }
}


static void outputSoundAsText(const int length, float *buff)
{

   fprintf(stdout, "3 TXTTXTTXT outputSoundAsText\n");
   strncpy(filename, filenamebase, 6);
   strcat(filename, filenameraw);
   strcat(filename, ".txt");
   outfile = fopen(filename, "a");
   if(outfile == NULL){
      fprintf(stdout, "File Noch nicht da.\n");
   }
   //if(outfile){
   //	fwrite(buff, sizeof(float), length, outfile);
   //}else{
   //	fprintf(stdout, "Could not open Text file.\n");
   //}

   // the write status. Will be set to 0 if successful and passed to afterSoundAsText()
   int ws = -1;
   if(outfile){
      //yellstatus();
      int i;
      for(i = 0; i < length; ++i){
         fprintf(outfile, "%f\n", buff[i]);
      }
      int cr = fclose(outfile);

      if(cr == 0){
	 fprintf(stdout, "Txt file closed.\n");
      }else{
	 fprintf(stdout, "Error closing txt file.\n");
      }
      outfile = NULL;
      ws = 0;
   }else{
      fprintf(stdout, "Could not open Text file.\n");
   }
   txt_out_result = ws;

}
#ifdef ESCWYP_SNDFILE_YES
static void outputSoundAsWav(const int length, float *buff)
{

   fprintf(stdout, "3 WAVWAV outputSoundAsWav\n");
   strncpy(filename, filenamebase, 6);
   strcat(filename, filenameraw);
   char ft[4] = "wav";
   int worked = 1;
   if(sndfile == NULL){
      worked = samplot_write_to_file(buff, length, filename, ft, 48000, &sndfile);
   }else{
      worked = samplot_append_to_file(buff, length, sndfile);
   }
   if(worked == 0){
      fprintf(stdout, "Success writing %s.%s sndfile=%x.\n", filename, ft, sndfile);
   }else{
      fprintf(stdout, "Error writing %s File.\n", ft);
   }
   wav_out_result = worked;

}
#endif

static void afterSoundAsText(int status)
{
      fprintf(stdout, "E C H I afterSoundAsText\n");
      if(escwyp_rec_progress_cb != NULL){
         //escwyp_rec_progress_cb(0.0);
      }
      //bar_rec_fun(0.0);
      strncpy(txt_out_status, filename, 51);
      if(status != 0){
         strcat(txt_out_status, " could not be");
      }
      strcat(txt_out_status, " written.");
      if(escwyp_rec_lab_cb != NULL){
         escwyp_rec_lab_cb(0, txt_out_status);
      }
      //lab_rec_fun(0, txt_out_status);
      fprintf(stdout, "E C H II afterSoundAsText\n");
}

void initTxtOut()
{

   txt_buff = (float *) malloc(txt_buff_length * sizeof(float));
   sem_init(&sem, 0, 1);
   int semv = 0;
   sem_getvalue(&sem, &semv);
   fprintf(stdout, "Semaphore of out_txt %i\n", semv);
   buffs[0].b = malloc(txt_buff_length * sizeof(float));
   buffs[1].b = malloc(txt_buff_length * sizeof(float));
   sem_init(&(buffs[0].s), 0, 1);
   sem_init(&(buffs[1].s), 0, 1);
      semv = 0;
      sem_getvalue(&(buffs[0].s), &semv);
      fprintf(stdout, "Got semaIphore of out_txt: val=%i\n", semv);
}

float *getTxtBuff(const int length)
{
	if(length >= 0){
		if(txt_buff_length >= txt_buff_index + length){ 
			txt_buff_index += length;
			return txt_buff-length;
		}else{
			return NULL;
		}
	}else{

		return NULL;
	}

}

int getTxtBuffIndex()
{

	return txt_buff_index;

}
int getTxtBuffLength()
{

	return txt_buff_length;

}

int get_output_txt()
{
	return output_txt;
}

static int set_output_txt(const int val)
{
   int valset = 0;

      if(val >= 0 && val < 5){
         output_txt = val;
      }else{
         valset = -1;
      }

   return valset;
}

void outTxtRecOnArm(const int val)
{
 //Call this to start recording after outTxtNotes() has been called
  output_txt_onarm = val;
  fprintf(stdout, "outTxtRecOnArm %i.\n", val);
  printstatus();
}

void outTxtRec()
{
 //Call this to start recording now
   int sr = 0;
   if(output_txt_onarm == 0){
      sr = set_output_txt(2);
   }
   if(output_txt_onarm == 1 && output_txt_notes == 0){
      sr = set_output_txt(1);
   }
   if(output_txt_onarm == 1 && output_txt_notes == 1){
      sr = set_output_txt(2);
   }
   if(sr < 0){
      fprintf(stdout, "outTxtRec: could not set output_txt: ret=%i\n", sr);
   }else{
      int semv = -1;
      int sr = -1;
      int se = -1;
      sr = sem_getvalue(&sem, &semv);
      if(semv > 0){
         escwyp_gen_random_string(filenameraw, 1);
      }else{
         fprintf(stdout, "outTxtRec: Cannot get value of semaphore of out_txt: ret=%i err=%i\n", sr, se);
      }
   }
         
   fprintf(stdout, "outTxtRec.\n");
   printstatus();
   //yellstatus();
}

void outTxtStop()
{
 //Call this to stop recording or cancel an arming with outTxtRecOnArm()
   int sr = set_output_txt(3);
   if(sr < 0){
      fprintf(stdout, "outTxtStop: could not set output_txt: ret=%i\n", sr);
   }
   fprintf(stdout, "outTxtStop.\n");
   printstatus();
   //yellstatus();
}

void outTxtRecOffArm(const int val)
{
 //Call this to stop recording once outTxtSilence() has been called
  output_txt_offarm = val;
  fprintf(stdout, "outTxtRecOffArm %i.\n", val);
  printstatus();
}

void outTxtNotes()
{
 //Call this to notify out_txt that notes just startet playing
  output_txt_notes = 1;
  if(output_txt_onarm == 1 && output_txt == 1){
      int sr = set_output_txt(2);
      if(sr < 0){
         fprintf(stdout, "outTxtNotes: could not set output_txt: ret=%i\n", sr);
      }
     //yellstatus();
  }
  fprintf(stdout, "outTxtNotes.\n");
  printstatus();
}

void outTxtSilence()
{
 //Call this to notify out_txt that notes have ceased and we have silence
   output_txt_notes = 0;
   if(output_txt_offarm == 1){
      int sr = set_output_txt(0);
      if(sr < 0){
         fprintf(stdout, "outTxtSilence: could not set output_txt: ret=%i\n", sr);
      }
   }
   fprintf(stdout, "outTxtSilence.\n");
   printstatus();
}

void printstatus()
{
  fprintf(stdout, "OUT TXT STATUS _____.\n");
  fprintf(stdout, "output_txt = %i.\n", output_txt);
  fprintf(stdout, "output_txt_offarm %i.\n", output_txt_offarm );
  fprintf(stdout, "output_txt_onarm %i.\n", output_txt_onarm );
  fprintf(stdout, "output_txt_notes %i.\n", output_txt_notes );
  fprintf(stdout, "SUTATS TXT TUO _____.\n");

} 
static void yellstatus()
{

   if(escwyp_rec_lab_cb != NULL){
      switch(output_txt){
         case 0:{
            escwyp_rec_lab_cb(0, "Idle");
            break;
         }
         case 1:{
            escwyp_rec_lab_cb(0, "Armed - waiting for note");
            break;
         }
         case 2:{
            escwyp_rec_lab_cb(0, "Recording");
            break;
         }
         case 3:{
            escwyp_rec_lab_cb(0, "Writing to disk");
            break;
         }
      }
   }
}
int get_output_txt_status()
{
}
int get_output_wav_status()
{
}
char *get_output_filename()
{
}
