// Copyright 2015, Jean Rene Dawin
//
// This Library is free software: you can redistribute it and/or modify
// it under the terms of the GNU Lesser General Public License as published by
// the Free Software Foundation, either version 2.1 of the License, or
// (at your option) any later version. See http://www.gnu.org/licenses/

#ifndef ESCWYP_OUT_TXT_EXTERN_H
#define ESCWYP_OUT_TXT_EXTERN_H
#include <stdio.h>

extern int sound_text_counter;
void outTxtCopy(const int length, const float *buff);
void initTxtOut();
float *getTxtBuff(const int length);
int getTxtBuffIndex();
int getTxtBuffLength();
int get_output_txt();
int set_output_txt(const int val);
void printstatus();
int get_output_txt_status();
int get_output_wav_status();
char *get_output_filename();


void outTxtRecOnArm(const int val); //Call this to start recording after outTxtNotes() has been called
void outTxtRec(); //Call this to start recording now
void outTxtStop(); //Call this to stop recording or cancel an arming with outTxtRecOnArm()
void outTxtRecOffArm(const int val); //Call this to stop recording once outTxtSilence() has been called
void outTxtNotes(); //Call this to notify out_txt that notes just startet playing
void outTxtSilence(); //Call this to notify out_txt that notes have ceased and we have silence

extern void (*escwyp_rec_progress_cb)(const float f);
extern void (*escwyp_rec_lab_cb)(const int i, const char *c);
extern void (*escwyp_rec_btns_cb)(void);

#endif
