// Copyright 2015, Jean Rene Dawin
//
// This program is free software: you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation, either version 2 of the License, or
// (at your option) any later version. See License-GPL-2.txt.

#ifndef ESCWYP_REC_GUI_ELM_H
#define ESCWYP_REC_GUI_ELM_H
#include "Evas.h"
#include <semaphore.h>

static sem_t sem_bar;
static sem_t sem_lab;
static int btn_rec_state = 0;
static char lab_rec_str[100] = " ";

static Evas_Object *btn_rec;
static Evas_Object *bar_rec;
static Evas_Object *chk_aton_rec;
static Evas_Object *chk_atoff_rec;
static Evas_Object *lab_rec;
static Ecore_Timer *rec_status_timer;
static int rec_status_array_size = 1;
static int rec_status_text_size = 255;
static int rec_status_new_index = 0;
static int rec_status_last_printed_index = 0; /* rec_status_array_size-1 */
struct rec_status{
   char *text;
   int status;
};
static struct rec_status *rec_status_array;

void recInitGuiElm();
static void btn_rec_fun(void *data, Evas_Object *obj, void *event_info);
static void chk_rec_fun(void *data, Evas_Object *obj, void *event_info);
static void chk_aton_rec_fun(void *data, Evas_Object *obj, void *event_info);
static void chk_atoff_rec_fun(void *data, Evas_Object *obj, void *event_info);
static Eina_Bool rec_status_func(void *data);
void lab_rec_fun(const int state, const char *str);

void recPackGui(Evas_Object *box, Evas_Object *box2);
void recUnpackGui(Evas_Object *box, Evas_Object *box2);
void bar_rec_fun(const float val);
void btns_rec_fun();
void recHideBtn();
void recShowBtn();
void recHideChks();
void recShowChks();

#endif
