// Copyright 2014-2015, Jean Rene Dawin
//
// This Library is free software: you can redistribute it and/or modify
// it under the terms of the GNU Lesser General Public License as published by
// the Free Software Foundation, either version 2.1 of the License, or
// (at your option) any later version.
//
// This Library is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU Lesser General Public License for more details.
//
// You should have received a copy of the GNU Lesser General Public License
// along with this Library.  If not, see <http://www.gnu.org/licenses/>.

#ifndef ESCWYP_SINE_GRASS_EXTERN_H
#define ESCWYP_SINE_GRASS_EXTERN_H
#include "escwyp_sine_grass_params.h"

void sine_grass_default_params(struct sine_grass_params *the_params);
void print_params_sine_grass(struct sine_grass_params *the_params);

//-------------- GUI-ELEMS-STUFF
int sine_grass_get_grass_mowed();
float sine_grass_get_grass_hill_fraction();
float sine_grass_get_lawn_length_variation_frac();

void sine_grass_set_grass_mowed(const int value);
void sine_grass_set_grass_hill_fraction(const float value);
void sine_grass_set_lawn_length_variation_frac(const float value);

//----------- PARAMS_STUFF
int sine_grass_params_lawn_length_variation_max_get(); 
int sine_grass_params_lawn_length_get(); 
float sine_grass_params_sine_grass_freq_get(); 

void sine_grass_params_lawn_length_variation_max_set(const int val); 
void sine_grass_params_lawn_length_set(const int val); 
void sine_grass_params_sine_grass_freq_set(const float val); 

//void sineGrassInitGui(const int hidden);
void sine_grass_refresh_parameters();
void sine_grass_set_params(struct sine_grass_params *params);
void sine_grass_set_freq(const float freq);
void sine_grass_init_values(const float freq, const unsigned int srate);
void makeSineGrass(const int length, float *buff_L);
void sine_grass_set_self_control(const int value);
int sine_grass_get_self_control();

//void sineGrassPackGui(Evas_Object *box);
//void sineGrassUnpackGui(Evas_Object *box);
#endif
