// Copyright 2015, Jean Rene Dawin
//
// This Library is free software: you can redistribute it and/or modify
// it under the terms of the GNU Lesser General Public License as published by
// the Free Software Foundation, either version 2.1 of the License, or
// (at your option) any later version.
//
// This Library is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU Lesser General Public License for more details.
//
// You should have received a copy of the GNU Lesser General Public License
// along with this Library.  If not, see <http://www.gnu.org/licenses/>.

#include <stdio.h>
#include <stdlib.h>
#include <math.h>
#include <time.h>

void random_seed_update(const int seed){

   if(seed > 0){
      srandom(seed);
   }else{
      srandom(time(0));
   }
}

int int_random(const int low, const int high){

   int tmp_high = high - low;
   float rando = (float) tmp_high*random()/RAND_MAX;
   int randoint = (int) trunc(rando);
   return randoint+low;

}

float float_random(const float low, const float high){

   float tmp_high = high - low;
   float rando = (float) tmp_high*random()/RAND_MAX;
   return rando+low;

}

void int_randoms_restricted(int *returner, unsigned const int returner_num, const int low, const int high, int *restrictions, unsigned const int restrictions_num, unsigned const short unique){

   int tmp_high = high - low;
   int i, j, collision;
   float rando; 
   int randoint;

   for(i = 0; i < returner_num; ++i){
      collision = 0;
      rando = (float) tmp_high*random()/RAND_MAX;
      randoint = (int) trunc(rando);
      for(j = 0; j < i && unique == 1; ++j){
         if(returner[j] == randoint+low){
            collision = 1; 
            break;
         }
      }
      for(j = 0; j < restrictions_num; ++j){
         if(restrictions[j] == randoint+low){
            collision = 2; 
            break;
         }
      }
      if(collision == 0){
         returner[i] = randoint+low;
      }else{
         --i;
      }
         
   }

}

void float_randoms_restricted(float *returner, unsigned const int returner_num, const float low, const float high, float *restrictions, unsigned const int restrictions_num, unsigned const short unique){

   float tmp_high = high - low;
   int i, j, collision;
   float rando; 

   for(i = 0; i < returner_num; ++i){
      collision = 0;
      rando = (float) tmp_high*random()/RAND_MAX;
      for(j = 0; j < i && unique == 1; ++j){
         if(returner[j] == rando+low){
            collision = 1; 
            break;
         }
      }
      for(j = 0; j < restrictions_num; ++j){
         if(restrictions[j] == rando+low){
            collision = 2; 
            break;
         }
      }
      if(collision == 0){
         returner[i] = rando+low;
      }else{
         --i;
      }
         
   }

}
